/* nmed2ris.h: header file for nmed2ris.c */
/* markus@mhoenicka.de 8-13-00 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, see <http://www.gnu.org/licenses/>

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* $Id: nmed2ris.h,v 1.3 2002/12/13 20:34:47 mhoenicka Exp $ */

/* this is enough for all but AB and N1 fields in refdb. The latter don't
   need any transformation so we can simply read on until we hit the end */
#define INFILE_CHUNK_SIZE 65536

/* defs for input file types */
#define BIOMEDNET 0
#define CCOD 1
#define GRATEMED 2
#define HEALTHGATE 3
#define KNOWFINDER 4
#define PUBMED 5

struct convstate {
  int n_convert_error; /* indicates conversion error */
  int n_outomem; /* indicates out-of-memory error */
  int n_outerror; /* error while writing to output stream */
  int n_read_err; /* indicates error while reading */
  int n_read_incomplete; /* set to 1 if incomplete line is read */
};

int convert_author(char* inbuffer);
int add_subheading(char* inbuffer);
int write_source(char* inbuffer);
int convert_data(char** inbuffer, int n_source_type);
int convert_line(char* inbuffer, int n_source_type);
int convert_line_kf(char* inbuffer);
int convert_line_hg(char* inbuffer);
int convert_line_rm(char* inbuffer);
int convert_line_pm(char* inbuffer);
int write_out(char* inbuffer);
int skip_lines_fp(char* inbuffer, FILE* fp_infile, struct convstate* ptr_cstate);
int skip_lines_s(char* inbuffer);
int convert_ref_fp(char** inbuffer, int* n_waitfortype, int n_source_type, struct convstate* ptr_cstate);
int convert_ref_s(char** inbuffer, int* n_waitfortype, int n_source_type, struct convstate* ptr_cstate);
char* getln_s(char** inbuffer);

void log_print(int priority, char* string);
void pipehandler(int sig);

